/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package salidasautomaticas.mysqldao;

import java.sql.Connection;
import java.time.LocalDate;
import java.time.LocalTime;
import java.util.Iterator;
import org.json.JSONArray;
import org.json.JSONObject;
import salidasautomaticas.dao.SalidasDAO;
import salidasautomaticas.util.EstandarDAO;

/**
 *
 * @author sistem19user
 */
public class SalidasMysqlDAO implements SalidasDAO {

    @Override
    public JSONArray obtenerHorariosSalida() throws Exception {
        Connection cn = MysqlDAOFactory.obtenerConexion("nuevo");
        int diaSemana = obtenerDiaSemana();
        String query = "SELECT ? as salida FROM (\n"
                + "SELECT\n"
                + "	p.salidaLV,\n"
                + "	p.salidaS\n"
                + "FROM\n"
                + "	asistencia a\n"
                + "INNER JOIN personal p ON a.codper = p.codper\n"
                + "INNER JOIN salidas_update su ON p.codcargo = su.codcargo\n"
                + "WHERE\n"
                + "	a.fecha_asis BETWEEN '2018-04-03' AND '2018-04-05'\n"
                + "AND p.retirado = 0\n"
                + "AND p.horaing = su.horaLV\n"
                + "AND p.mining = su.minutoLV\n"
                + "AND p.horaingsabado = su.sabadoLV\n"
                + "AND p.miningsabado = su.sabadoS\n"
                + "AND NOT p.codlocal IN ('L035', 'L053', 'L038')\n"
                + "AND NOT p.pronoe = 1\n"
                + "AND NOT p.codcargo IN (71, 13)\n"
                + "AND NOT p.horaing > 19\n"
                + "AND NOT p.salidaS = '') as tabla WHERE NULLIF( ? , '') is NOT null  GROUP BY ? ";

        if (diaSemana >= 1 && diaSemana <= 5) {
            query = query.replaceAll("\\?", "tabla.salidaLV");
        } else if (diaSemana == 6) {
            query = query.replaceAll("\\?", "tabla.salidaS");
        }
        JSONArray jsonArray = EstandarDAO.getInstance().consultar(cn, query);

        return jsonArray;
    }

    private int obtenerDiaSemana() {
        int diaSemana;
        LocalDate date = LocalDate.now();
        diaSemana = date.getDayOfWeek().getValue();

        return diaSemana;
    }

    @Override
    public JSONArray obtenerAsistencias(String horaProgramada) throws Exception {
        Connection cn = MysqlDAOFactory.obtenerConexion("nuevo");
        int diaSemana = obtenerDiaSemana();
        String query = "SELECT\n"
                + "	asistencia.codasis,\n"
                + "asistencia.fecha_asis,\n"
                + "(WEEKDAY(asistencia.fecha_asis) + 1) AS numDia,\n"
                + "? \n"
                + "FROM\n"
                + "	asistencia\n"
                + "INNER JOIN personal ON asistencia.codper = personal.codper\n"
                + "WHERE\n"
                + "	asistencia.horasal = ''\n"
                + "AND asistencia.minsal = ''\n"
                + "AND ( ? <='*' AND asistencia.fecha_asis='2018-04-05')\n"
                + "OR (asistencia.fecha_asis BETWEEN '2018-04-03' AND '2018-04-04')\n"
                + "AND ? is not NULL  \n"
                + "AND (WEEKDAY(asistencia.fecha_asis) + 1) !=7 AND personal.retirado=0 ";

        if (diaSemana >= 1 && diaSemana <= 5) {
            query = query.replaceAll("\\?", "personal.salidaLV");
        } else if (diaSemana == 6) {
            query = query.replaceAll("\\?", "personal.salidaS");
        }
        query = query.replaceAll("\\*", horaProgramada);
        JSONArray jsonArray = EstandarDAO.getInstance().consultar(cn, query);

        return jsonArray;
    }

    @Override
    public JSONObject actualizarSalida() throws Exception {
        JSONObject resultado = null;
        Connection cn = MysqlDAOFactory.obtenerConexion("nuevo");
        LocalTime horaSistema = LocalTime.now();
        int cantMinSistema = horaSistema.getHour() * 60 + horaSistema.getMinute();
        JSONArray listadoHoras = obtenerHorariosSalida();
        System.out.println("listadoHoras " + listadoHoras);
        for (Iterator iterator = listadoHoras.iterator(); iterator.hasNext();) {
            System.out.println("" + 1);
            int aleatorioHora = 0, aleatorioMin = 0;
            JSONObject objHora = (JSONObject) iterator.next();
            System.out.println("objHora " + objHora);
            String[] splitHora = objHora.getString("salida").split(":");
            int cantidadMin = Integer.parseInt(splitHora[0]) * 60 + Integer.parseInt(splitHora[1]);

            if (cantidadMin > cantMinSistema) {
                //Reprogramacion
                System.out.println("Me reprogramo");
            } else {
                System.out.println("Programo");
                JSONArray listadoProgramar = obtenerAsistencias(objHora.getString("salida"));
                System.out.println("listadoProgrmar " + listadoProgramar);
                for (Iterator iterator1 = listadoProgramar.iterator(); iterator1.hasNext();) {
                    JSONObject objPrograma = (JSONObject) iterator1.next();
                    
                    String[] splitHoraConsulta = objPrograma.getString("salidaLV").split(":");
                    int min = Integer.parseInt(splitHoraConsulta[1]);
                    int hora = Integer.parseInt(splitHoraConsulta[0]);
                    System.out.println("obj " + objPrograma);
                    //Actualizacion de salidas
                    if (min == 0) {
                        aleatorioHora = (int) Math.floor(Math.random() * (hora - (hora - 1) + 1) + (hora - 1));
                    } else {
                        aleatorioHora = hora;
                    }
                    if (hora == aleatorioHora) {
                        if (min == 0) {
                            aleatorioMin = (int) Math.floor(Math.random() * (3 - 0 + 1) + 0);
                        } else {
                            aleatorioMin = (int) Math.floor(Math.random() * (33 - 27 + 1) + 27);
                        }
                    } else {
                        aleatorioMin = (int) Math.floor(Math.random() * (59 - 56 + 1) + 56);
                    }

                    String queryPersonal = "update asistencia set horasal= ?,minsal=? where codasis=? ";
                    JSONArray parametros = new JSONArray();
                    parametros.put(aleatorioHora);
                    parametros.put(aleatorioMin);
                    parametros.put(objPrograma.getString("codasis"));
//                    System.out.println("consulta "+queryPersonal+ " "+parametros);
                    resultado = EstandarDAO.getInstance().ejecutar(cn, queryPersonal, parametros);

                }
            }
        }

        return resultado;
    }

}
